--- old/./Makefile	2013-10-21 19:08:23.576195909 +0000
+++ new/./Makefile	2013-10-21 19:08:23.592603001 +0000
@@ -179,10 +179,10 @@
 	    gmake DESTDIR=$(PROTO) install)
 	touch $@
 
-0-livesrc-stamp: src/bootparams.c
+0-livesrc-stamp: src/bootparams.c 0-illumos-stamp 0-extra-stamp
 	(cd $(ROOT)/src && \
-	    gmake DESTDIR=$(PROTO) && \
-	    gmake DESTDIR=$(PROTO) install)
+	    gmake NATIVEDIR=$(STRAP_PROTO) DESTDIR=$(PROTO) && \
+	    gmake NATIVEDIR=$(STRAP_PROTO) DESTDIR=$(PROTO) install)
 	touch $@
 
 0-man-stamp:
--- old/src/Makefile	2013-10-21 19:08:23.865465957 +0000
+++ new/src/Makefile	2013-10-21 19:08:23.878710595 +0000
@@ -116,6 +116,15 @@
 $(KSTAT.NODE) :	LIBS +=		-lkstat
 
 #
+# The lockfd Node add-on is based on v8plus, which has its own system of
+# Makefiles.
+#
+LOCKFD_BINDING.NODE =		node-lockfd/lib/lockfd_binding.node
+
+LOCKFD_SRC_DIR =		$(PWD)/node-lockfd/src
+LOCKFD_V8PLUS_DIR =		$(PWD)/node-lockfd/node_modules/v8plus
+
+#
 # The dtrace-provider add-on uses a combination of C, assembly and C++ files in
 # multiple directories.
 #
@@ -314,6 +323,7 @@
 	$(EXPAT.NODE) \
 	$(DTRACE_PROVIDER.NODE) \
 	$(KSTAT.NODE) \
+	$(LOCKFD_BINDING.NODE) \
 	$(MICROTIME.NODE) \
 	$(SYSLOG.NODE) \
 	$(SQLITE3_BINDINGS.NODE) \
@@ -344,6 +354,8 @@
 	mkdir -m 0755 -p $(PREFIX_NODE)/node_modules
 	cp -Pr node_modules/* $(PREFIX_NODE)/node_modules
 	cp $(KSTAT.NODE) $(PREFIX_NODE)/node_modules/
+	cp node-lockfd/lib/index.js $(PREFIX_NODE)/node_modules/lockfd.js
+	cp $(LOCKFD_BINDING.NODE) $(PREFIX_NODE)/node_modules/lockfd_binding.node
 	cp $(MICROTIME.NODE) $(PREFIX_NODE)/node_modules/
 	rm -rf $(DESTDIR)/usr/vm
 	cp -PR vm $(DESTDIR)/usr/
@@ -462,6 +474,7 @@
 	-rm -f $(TARGETS) $(SMARTDC_TARGETS) $(SMARTDC_LIB_TARGETS) *.o \
 	    $(CLEANFILES)
 	-rm -rf node-sqlite3/build
+	cd $(LOCKFD_SRC_DIR) && $(MAKE) clean
 
 include Makefile.targ
 
@@ -496,6 +509,23 @@
 	$(GXX) $(CPPFLAGS) $(CXXFLAGS) $(LDFLAGS) -o $@ $< $(LIBS)
 
 #
+# node-lockfd is built using the v8plus-based Makefile contained within the
+# project.  We use LD_OPTIONS, here, to induce the linker to include libc,
+# which gcc as configured in proto.strap does not, but which other C compilers
+# generally do.
+#
+$(LOCKFD_BINDING.NODE): FRC
+	cd $(LOCKFD_SRC_DIR) && \
+	LD_OPTIONS=-lc \
+	$(MAKE) \
+		CC=$(GCC) CXX=$(GXX) \
+		PREFIX_NODE=$(PREFIX_NODE) \
+		NODE_EXEC=$(NODE_EXEC) \
+		V8PLUS=$(LOCKFD_V8PLUS_DIR) \
+		CTFCONVERT=$(CTFCONVERT) \
+		CTFMERGE=$(CTFMERGE)
+
+#
 # The next two are used to build libusdt files into
 # $(DTRACE_PROVIDER_OBJDIR)/libusdt/*.o, instead of building libusdt.a
 #
@@ -553,3 +583,5 @@
 
 $(ZUTIL_BINDINGS.NODE): $(ZUTIL_BINDINGS_OBJS)
 	$(GXX) $(LDFLAGS) -o $@ $(ZUTIL_BINDINGS_OBJS) $(LIBS)
+
+FRC:
--- old/src/Makefile.defs	2013-10-21 19:08:24.133225165 +0000
+++ new/src/Makefile.defs	2013-10-21 19:08:24.146442063 +0000
@@ -23,18 +23,24 @@
 
 BASE =		$(PWD)
 DESTDIR =	$(BASE)/../proto
+NATIVEDIR =	$(BASE)/../proto.strap
+ILLUMOS_SRC =	$(BASE)/../projects/illumos/usr/src
 
 ifeq ($(shell uname -s),Darwin)
 MAKE =		make
 PATH =		$(DESTDIR)/usr/bin:/bin:/usr/bin:/usr/sbin:/sbin:/opt/local/bin
 else
 MAKE =		gmake
-PATH =		$(DESTDIR)/usr/bin:/usr/bin:/usr/sbin:/sbin:/opt/local/bin
+PATH =		$(NATIVEDIR)/usr/bin:/usr/bin:/usr/sbin:/sbin:/opt/local/bin
 endif
 
 PARALLEL =	-j128
-GCC =		$(DESTDIR)/usr/bin/gcc
-GXX =		$(DESTDIR)/usr/bin/g++
+GCC =		$(NATIVEDIR)/usr/bin/gcc
+GXX =		$(NATIVEDIR)/usr/bin/g++
+
+CTFBINDIR =	$(ILLUMOS_SRC)/tools/proto/root_i386-nd/opt/onbld/bin/i386
+CTFMERGE =	$(CTFBINDIR)/ctfmerge
+CTFCONVERT =	$(CTFBINDIR)/ctfconvert
 
 SYSINCDIRS =	/usr/include
 SYSLIBDIRS =	/usr/lib /lib
@@ -44,6 +50,7 @@
 		    -Wl,-zfatal-warnings
 
 PREFIX_NODE =	$(DESTDIR)/usr/node/0.8
+NODE_EXEC =	$(NATIVEDIR)/usr/node/0.8/bin/node
 
 DEBUG_FLAGS =	-g
 WARN_FLAGS =	-Wall -Wextra -Werror
--- old/src/manifest	2013-10-21 19:08:24.415296764 +0000
+++ new/src/manifest	2013-10-21 19:08:24.427991244 +0000
@@ -402,6 +402,8 @@
 f usr/node/0.8/node_modules/dtrace-provider.node 0444 root bin
 f usr/node/0.8/node_modules/getopt.js 0444 root bin
 f usr/node/0.8/node_modules/kstat.node 0444 root bin
+f usr/node/0.8/node_modules/lockfd.js 0444 root bin
+f usr/node/0.8/node_modules/lockfd_binding.node 0444 root bin
 f usr/node/0.8/node_modules/microtime.node 0444 root bin
 f usr/node/0.8/node_modules/onlyif.js 0444 root bin
 f usr/node/0.8/node_modules/sprintf.js 0444 root bin
--- /dev/null	2013-10-21 19:08:24.000000000 +0000
+++ new/src/node-lockfd/.gitignore	2013-10-21 19:08:24.742138744 +0000
@@ -0,0 +1,4 @@
+src/*.o
+src/v8plus_errno.[ch]
+lib/*.node
+src/mapfile_node
--- /dev/null	2013-10-21 19:08:24.000000000 +0000
+++ new/src/node-lockfd/LICENSE	2013-10-21 19:08:24.909761650 +0000
@@ -0,0 +1,18 @@
+Copyright (c) 2013, Joyent, Inc. All rights reserved.
+
+Permission is hereby granted, free of charge, to any person obtaining a copy of
+this software and associated documentation files (the "Software"), to deal in
+the Software without restriction, including without limitation the rights to
+use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
+the Software, and to permit persons to whom the Software is furnished to do so,
+subject to the following conditions:
+
+The above copyright notice and this permission notice shall be included in all
+copies or substantial portions of the Software.
+
+THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
+FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
+COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
+IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
+CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
--- /dev/null	2013-10-21 19:08:25.000000000 +0000
+++ new/src/node-lockfd/lib/index.js	2013-10-21 19:08:25.209823974 +0000
@@ -0,0 +1,63 @@
+/* vim: set syntax=javascript ts=8 sts=8 sw=8 noet: */
+
+var BINDING = require('./lockfd_binding');
+
+function
+check_arg(pos, name, value, type)
+{
+	if (typeof (value) !== type) {
+		throw (new Error('argument #' + pos + ' (' + name +
+		    ') must be of type ' + type));
+	}
+}
+
+function
+lockfd(fd, callback)
+{
+	check_arg(1, 'fd', fd, 'number');
+	check_arg(2, 'callback', callback, 'function');
+
+	BINDING.lock_fd(fd, "write", false, function (ret, errno, errmsg) {
+		if (ret === -1) {
+			var err = new Error('File Locking Error: ' + errmsg);
+			err.__errno = errno;
+
+			callback(err);
+			return;
+		}
+
+		callback(null);
+	});
+}
+
+function
+lockfdSync(fd)
+{
+	var cb_fired = false;
+	var err;
+
+	check_arg(1, 'fd', fd, 'number');
+
+	BINDING.lock_fd(fd, "write", true, function (ret, errno, errmsg) {
+		cb_fired = true;
+
+		if (ret === -1) {
+			err = new Error('File Locking Error: ' + errmsg);
+			err.__errno = errno;
+			return;
+		}
+	});
+
+	if (!cb_fired) {
+		throw (new Error('lockfdSync: CALLBACK NOT FIRED'));
+	} else if (err) {
+		throw (err);
+	}
+
+	return (null);
+}
+
+module.exports = {
+	lockfd: lockfd,
+	lockfdSync: lockfdSync
+};
--- /dev/null	2013-10-21 19:08:29.000000000 +0000
+++ new/src/node-lockfd/src/Makefile	2013-10-21 19:08:29.150842746 +0000
@@ -0,0 +1,25 @@
+#
+# Copyright (c) 2013 Joyent, Inc.  All rights reserved.
+#
+
+PREFIX_NODE :=	$(shell dirname $$(bash -c 'hash node; hash -t node'))/..
+V8PLUS :=       $(shell $(PREFIX_NODE)/bin/node -e 'require("v8plus");')
+
+include $(V8PLUS)/Makefile.v8plus.defs
+
+MODULE =	lockfd_binding
+
+SRCS =	\
+		lockfd.c
+
+ERRNO_JSON =	errno.json
+
+CC =		/opt/local/bin/gcc
+CXX =		/opt/local/bin/g++
+
+#WARN_FLAGS +=	-Wno-error=unused-parameter
+
+#LDFLAGS +=	-L/usr/lib/fm -R/usr/lib/fm
+LIBS +=		-lumem
+
+include $(V8PLUS)/Makefile.v8plus.targ
--- /dev/null	2013-10-21 19:08:29.000000000 +0000
+++ new/src/node-lockfd/src/lockfd.c	2013-10-21 19:08:29.463862908 +0000
@@ -0,0 +1,143 @@
+#include <stdlib.h>
+#include <stdio.h>
+#include <string.h>
+#include <assert.h>
+#include <fcntl.h>
+#include <errno.h>
+#include <unistd.h>
+#include <pthread.h>
+
+#include <libnvpair.h>
+
+#include "v8plus_glue.h"
+
+typedef struct lockfd_args {
+	v8plus_jsfunc_t lfa_cb;
+	int lfa_fd;
+	struct flock lfa_flock;
+	boolean_t lfa_run_sync;
+} lockfd_args_t;
+
+/*
+ * Worker thread for blocking fcntl() calls:
+ */
+static void *
+lockfd_thread(void *arg)
+{
+	lockfd_args_t *lfa = arg;
+	nvlist_t *ap;
+	int ret, en = 0;
+	char *errmsg = "";
+
+	errno = 0;
+	if ((ret = fcntl(lfa->lfa_fd, F_SETLKW, &lfa->lfa_flock)) == -1) {
+		errmsg = strerror(en);
+	}
+
+	/*
+	 * Call back into JS:
+	 */
+	ap = v8plus_obj(
+	    V8PLUS_TYPE_NUMBER, "0", (double) ret,
+	    V8PLUS_TYPE_NUMBER, "1", (double) en,
+	    V8PLUS_TYPE_STRING, "2", errmsg,
+	    V8PLUS_TYPE_NONE);
+	(void) v8plus_call(lfa->lfa_cb, ap);
+	nvlist_free(ap);
+
+	if (!lfa->lfa_run_sync) {
+		/*
+		 * Release our callback, held from the ititial call:
+		 */
+		v8plus_jsfunc_rele(lfa->lfa_cb);
+	}
+
+	free(lfa);
+
+	return (NULL);
+}
+
+/*
+ * Primary entrypoint from Javascript:
+ */
+static nvlist_t *
+lockfd_lockfd(const nvlist_t *ap)
+{
+	lockfd_args_t *lfa = calloc(1, sizeof (*lfa));
+	pthread_t newthr;
+	double double_fd;
+	char *type;
+
+	if (v8plus_args(ap, V8PLUS_ARG_F_NOEXTRA,
+	    V8PLUS_TYPE_NUMBER, &double_fd,
+	    V8PLUS_TYPE_STRING, &type,
+	    V8PLUS_TYPE_BOOLEAN, &lfa->lfa_run_sync,
+	    V8PLUS_TYPE_JSFUNC, &lfa->lfa_cb,
+	    V8PLUS_TYPE_NONE) != 0) {
+		free(lfa);
+		return (v8plus_error(V8PLUSERR_BADARG, "bad args"));
+	}
+	lfa->lfa_fd = double_fd;
+
+	/*
+	 * Configure the flock struct for locking:
+	 */
+	if (strcmp(type, "read") == 0) {
+		lfa->lfa_flock.l_type = F_RDLCK;
+	} else if (strcmp(type, "write") == 0) {
+		lfa->lfa_flock.l_type = F_WRLCK;
+	} else if (strcmp(type, "unlock") == 0) {
+		lfa->lfa_flock.l_type = F_UNLCK;
+	} else {
+		free(lfa);
+		return (v8plus_error(V8PLUSERR_BADARG, "bad args: type"));
+	}
+	lfa->lfa_flock.l_whence = SEEK_SET;
+	lfa->lfa_flock.l_start = 0;
+	lfa->lfa_flock.l_len = 0;
+
+
+	if (lfa->lfa_run_sync) {
+		/*
+		 * Run the blocking fcntl() call in the current thread:
+		 */
+		lockfd_thread(lfa);
+	} else {
+		/*
+		 * Hold this function so that we can call it later from
+		 * the other thread:
+		 */
+		v8plus_jsfunc_hold(lfa->lfa_cb);
+
+		/*
+		 * Create a thread for the blocking fcntl(F_SETLKW) call:
+		 */
+		if (pthread_create(&newthr, NULL, lockfd_thread, lfa) != 0) {
+			return (v8plus_error(V8PLUSERR_UNKNOWN,
+			    "could not create thread"));
+		}
+	}
+
+	return (v8plus_void());
+}
+
+/*
+ * v8plus Boilerplate
+ */
+const v8plus_c_ctor_f v8plus_ctor = NULL;
+const v8plus_c_dtor_f v8plus_dtor = NULL;
+const char *v8plus_js_factory_name = NULL;
+const char *v8plus_js_class_name = NULL;
+
+const v8plus_method_descr_t v8plus_methods[] = {};
+const uint_t v8plus_method_count =
+    sizeof (v8plus_methods) / sizeof (v8plus_methods[0]);
+
+const v8plus_static_descr_t v8plus_static_methods[] = {
+	{
+		sd_name: "lock_fd",
+		sd_c_func: lockfd_lockfd
+	}
+};
+const uint_t v8plus_static_method_count =
+    sizeof (v8plus_static_methods) / sizeof (v8plus_static_methods[0]);
